// THIS FILE IS AUTOMATICALLY GENERATED

#include "clientStubs.h"
#include "methodName.h"
#include "stack.h"
#include "os_socket.h"

SOCKET sockfd;
struct sockaddr_in my_addr;


int clientStubs_init(char* hosturl, int port)
{
  int res;

  res = os_socket_init();
  if (res)
  {
     fprintf(stderr,"initialization of sockets failed\n");
     return res;
  }

  sockfd = os_socket_client(port,hosturl,&my_addr);
  if (sockfd == 0)
  {
     fprintf(stderr,"os_socket_client failed");
     return -1;
  }

  connect(sockfd,(sockaddr*)&my_addr, sizeof(my_addr));

  return 0;
}

void clientStubs_deinit()
{
  os_socket_close(sockfd);
  os_socket_deinit();
}

inline void reallocStr(char **str)
{
   if (str)
    if (*str) (*str) = strdup(*str);
}


//! serializes the parameters, invokes remote method, deserializes results.
//! Strings are returned as pointers to the stack buffer. So they are
//! persistent only until next call to the same method if they are
//! not reallocated.
//! (automatically generated method)
int svc_sqlite_open(
                  STACK_Str in_filename ,
                  STACK_Int *out_errcode ,
                  STACK_Str *out_errmsg ,
                  STACK_Int *out_db_handle 
             )
{

  static SktStack* stack = 0;
  if (stack == 0)
    stack = new SktStack();
  else
    stack->reset();

  stack->writeByte(METHOD_sqlite_open);

  stack->writeStr(in_filename);

  int res = (stack->invoke(sockfd));

  if (res == STACK_OK)
  {
    res = stack->readInt();
    if (res == STACK_OK)
    {
     if (out_errcode != 0)
     {
       (*out_errcode) = stack->readInt();
     }
     else stack->readInt(); //skip parameter
     if (out_errmsg != 0)
     {
       (*out_errmsg) = stack->readStr();
       reallocStr(out_errmsg);
     }
     else stack->readStr(); //skip parameter
     if (out_db_handle != 0)
     {
       (*out_db_handle) = stack->readInt();
     }
     else stack->readInt(); //skip parameter
    }
  }
  return res;
}

//! serializes the parameters, invokes remote method, deserializes results.
//! Strings are returned as pointers to the stack buffer. So they are
//! persistent only until next call to the same method if they are
//! not reallocated.
//! (automatically generated method)
int svc_sqlite_close(
                  STACK_Int in_db_handle ,
				  STACK_Int *out_errorcode
             )
{

  static SktStack* stack = 0;
  if (stack == 0)
    stack = new SktStack();
  else
    stack->reset();

  stack->writeByte(METHOD_sqlite_close);

  stack->writeInt(in_db_handle);

  int res = (stack->invoke(sockfd));

  if (res == STACK_OK)
  {
    res = stack->readInt();
	*out_errorcode = res;
  }
  return res;
}

//! serializes the parameters, invokes remote method, deserializes results.
//! Strings are returned as pointers to the stack buffer. So they are
//! persistent only until next call to the same method if they are
//! not reallocated.
//! (automatically generated method)
int svc_sqlite_compile(
                  STACK_Int in_db_handle ,
                  STACK_Str in_sql ,
                  STACK_Int *out_tailIndex ,
                  STACK_Int *out_vm_handle ,
                  STACK_Int *out_errcode ,
                  STACK_Str *out_errmsg 
             )
{

  static SktStack* stack = 0;
  if (stack == 0)
    stack = new SktStack();
  else
    stack->reset();

  stack->writeByte(METHOD_sqlite_compile);

  stack->writeInt(in_db_handle);
  stack->writeStr(in_sql);

  int res = (stack->invoke(sockfd));

  if (res == STACK_OK)
  {
    res = stack->readInt();
    if (res == STACK_OK)
    {
     if (out_tailIndex != 0)
     {
       (*out_tailIndex) = stack->readInt();
     }
     else stack->readInt(); //skip parameter
     if (out_vm_handle != 0)
     {
       (*out_vm_handle) = stack->readInt();
     }
     else stack->readInt(); //skip parameter
     if (out_errcode != 0)
     {
       (*out_errcode) = stack->readInt();
     }
     else stack->readInt(); //skip parameter
     if (out_errmsg != 0)
     {
       (*out_errmsg) = stack->readStr();
       reallocStr(out_errmsg);
     }
     else stack->readStr(); //skip parameter
    }
  }
  return res;
}

//! serializes the parameters, invokes remote method, deserializes results.
//! Strings are returned as pointers to the stack buffer. So they are
//! persistent only until next call to the same method if they are
//! not reallocated.
//! (automatically generated method)
int svc_sqlite_step(
                  STACK_Int in_vm_handle ,
                  STACK_Int *out_errcode ,
                  STACK_StrArray *out_colValues ,
                  STACK_StrArray *out_colNames 
             )
{

  static SktStack* stack = 0;
  if (stack == 0)
    stack = new SktStack();
  else
    stack->reset();

  stack->writeByte(METHOD_sqlite_step);

  stack->writeInt(in_vm_handle);

  int res = (stack->invoke(sockfd));

  if (res == STACK_OK)
  {
    res = stack->readInt();
    if (res == STACK_OK)
    {

     if (out_errcode != 0)			// get sqlite error code
     {
       (*out_errcode) = stack->readInt();
     }
     else stack->readInt(); //skip parameter

     if (out_colValues != 0)		// read the column values
     {
       (*out_colValues) = stack->readStrArray();
     }
     else stack->readStrArray(); //skip parameter

     if (out_colNames != 0)			/// read the column names
     {
       (*out_colNames) = stack->readStrArray();
     }
     else stack->readStrArray(); //skip parameter
    }
  }
  return res;
}

//! serializes the parameters, invokes remote method, deserializes results.
//! Strings are returned as pointers to the stack buffer. So they are
//! persistent only until next call to the same method if they are
//! not reallocated.
//! (automatically generated method)
int svc_sqlite_finalize(
                  STACK_Int in_vm_handle 
                 ,
                  STACK_Int *out_errcode ,
                  STACK_Str *out_errmsg 
             )
{

  static SktStack* stack = 0;
  if (stack == 0)
    stack = new SktStack();
  else
    stack->reset();

  stack->writeByte(METHOD_sqlite_finalize);

  stack->writeInt(in_vm_handle);

  int res = (stack->invoke(sockfd));

  if (res == STACK_OK)
  {
    res = stack->readInt();
    if (res == STACK_OK)
    {
     if (out_errcode != 0)
     {
       (*out_errcode) = stack->readInt();
     }
     else stack->readInt(); //skip parameter
     if (out_errmsg != 0)
     {
       (*out_errmsg) = stack->readStr();
       reallocStr(out_errmsg);
     }
     else stack->readStr(); //skip parameter
    }
  }
  return res;
}

//! serializes the parameters, invokes remote method, deserializes results.
//! Strings are returned as pointers to the stack buffer. So they are
//! persistent only until next call to the same method if they are
//! not reallocated.
//! (automatically generated method)
int svc_sqlite_reset(
                  STACK_Int in_vm_handle 
                 ,
                  STACK_Int *out_errcode ,
                  STACK_Str *out_errmsg 
             )
{

  static SktStack* stack = 0;
  if (stack == 0)
    stack = new SktStack();
  else
    stack->reset();

  stack->writeByte(METHOD_sqlite_reset);

  stack->writeInt(in_vm_handle);

  int res = (stack->invoke(sockfd));

  if (res == STACK_OK)
  {
    res = stack->readInt();
    if (res == STACK_OK)
    {
     if (out_errcode != 0)
     {
       (*out_errcode) = stack->readInt();
     }
     else stack->readInt(); //skip parameter
     if (out_errmsg != 0)
     {
       (*out_errmsg) = stack->readStr();
       reallocStr(out_errmsg);
     }
     else stack->readStr(); //skip parameter
    }
  }
  return res;
}

//! serializes the parameters, invokes remote method, deserializes results.
//! Strings are returned as pointers to the stack buffer. So they are
//! persistent only until next call to the same method if they are
//! not reallocated.
//! (automatically generated method)
int svc_sqlite_changes(
                  STACK_Int in_db_handle 
                 ,
                  STACK_Int *out_count 
             )
{

  static SktStack* stack = 0;
  if (stack == 0)
    stack = new SktStack();
  else
    stack->reset();

  stack->writeByte(METHOD_sqlite_changes);

  stack->writeInt(in_db_handle);

  int res = (stack->invoke(sockfd));

  if (res == STACK_OK)
  {
    res = stack->readInt();
    if (res == STACK_OK)
    {
     if (out_count != 0)
     {
       (*out_count) = stack->readInt();
     }
     else stack->readInt(); //skip parameter
    }
  }
  return res;
}

//! serializes the parameters, invokes remote method, deserializes results.
//! Strings are returned as pointers to the stack buffer. So they are
//! persistent only until next call to the same method if they are
//! not reallocated.
//! (automatically generated method)
int svc_sqlite_last_insert_rowid(
                  STACK_Int in_db_handle 
                 ,
                  STACK_Int *out_rowid 
             )
{

  static SktStack* stack = 0;
  if (stack == 0)
    stack = new SktStack();
  else
    stack->reset();

  stack->writeByte(METHOD_sqlite_last_insert_rowid);

  stack->writeInt(in_db_handle);

  int res = (stack->invoke(sockfd));

  if (res == STACK_OK)
  {
    res = stack->readInt();
    if (res == STACK_OK)
    {
     if (out_rowid != 0)
     {
       (*out_rowid) = stack->readInt();
     }
     else stack->readInt(); //skip parameter
    }
  }
  return res;
}

//! serializes the parameters, invokes remote method, deserializes results.
//! Strings are returned as pointers to the stack buffer. So they are
//! persistent only until next call to the same method if they are
//! not reallocated.
//! (automatically generated method)
int svc_sqlite_interrupt(
                  STACK_Int in_db_handle 
             )
{

  static SktStack* stack = 0;
  if (stack == 0)
    stack = new SktStack();
  else
    stack->reset();

  stack->writeByte(METHOD_sqlite_interrupt);

  stack->writeInt(in_db_handle);

  int res = (stack->invoke(sockfd));

  if (res == STACK_OK)
  {
    res = stack->readInt();
    if (res == STACK_OK)
    {
    }
  }
  return res;
}

//! serializes the parameters, invokes remote method, deserializes results.
//! Strings are returned as pointers to the stack buffer. So they are
//! persistent only until next call to the same method if they are
//! not reallocated.
//! (automatically generated method)
int svc_sqlite_libversion(
                 
                  STACK_Str *out_version 
             )
{

  static SktStack* stack = 0;
  if (stack == 0)
    stack = new SktStack();
  else
    stack->reset();

  stack->writeByte(METHOD_sqlite_libversion);


  int res = (stack->invoke(sockfd));

  if (res == STACK_OK)
  {
    res = stack->readInt();
    if (res == STACK_OK)
    {
     if (out_version != 0)
     {
       (*out_version) = stack->readStr();
     }
     else stack->readStr(); //skip parameter
    }
  }
  return res;
}

#if 0
//! serializes the parameters, invokes remote method, deserializes results.
//! Strings are returned as pointers to the stack buffer. So they are
//! persistent only until next call to the same method if they are
//! not reallocated.
//! (automatically generated method)
int svc_sqlite_libencoding(
                 
                  STACK_Str *out_encoding 
             )
{

  static SktStack* stack = 0;
  if (stack == 0)
    stack = new SktStack();
  else
    stack->reset();

  stack->writeByte(METHOD_sqlite_libencoding);


  int res = (stack->invoke(sockfd));

  if (res == STACK_OK)
  {
    res = stack->readInt();
    if (res == STACK_OK)
    {
     if (out_encoding != 0)
     {
       (*out_encoding) = stack->readStr();
     }
     else stack->readStr(); //skip parameter
    }
  }
  return res;
}
#endif

int svc_sqlite_errmsg(
					  STACK_Int in_db_handle ,
					  STACK_Str *out_msg_str
					  )
{
  static SktStack* stack = 0;
  if (stack == 0)
    stack = new SktStack();
  else
    stack->reset();

  stack->writeByte(METHOD_sqlite_errmsg);

  stack->writeInt(in_db_handle);

  int res = (stack->invoke(sockfd));

  if (res == STACK_OK)
  {
    res = stack->readInt();
    if (res == STACK_OK)
		{
		*out_msg_str = stack->readStr();
		}
  }
  return(res);
}
#ifdef ANDROMEDA
int svc_sqlite_db_exists(
                  STACK_Str in_filename ,
                  STACK_Int *out_errcode
             )
{

  static SktStack* stack = 0;
  if (stack == 0)
    stack = new SktStack();
  else
    stack->reset();

  stack->writeByte(METHOD_sqlite_db_exists);

  stack->writeStr(in_filename);

  int res = (stack->invoke(sockfd));

  if (res == STACK_OK)
  {
    res = stack->readInt();
    if (res == STACK_OK)
    {
     if (out_errcode != 0)
     {
       (*out_errcode) = stack->readInt();
     }
     else stack->readInt(); //skip parameter
    }
  }
  return res;
}
#endif



